function [x,iter,z,tcl,tcc]=fixedpoint(g,x0,tol,maxiter,C,D,Eopt,s)

% g is the function that we are going to solve
%X0 is an initial estimation
%tol is the precision
%maxiter is the maximum number of iterations

%next parameters are for the function to be solved:
%C is a vector that symbolizes the tx power
%D is a vector that symbolizes the electronic power
%Eopt is the optimal energy
%s is the packet length in bits

% Inicializacion de variables
iter=0;
incre=tol+1;
z(1,:)=x0;

while incre>tol & iter<maxiter  
   %Cuando no se cumpla una de las dos condiciones se saldra del bucle
   
   x=feval(g,x0,C,D,Eopt,s);
   incre=norm(x-x0);    % norm tiene la forma norm(v,(1,2  inf)) --> 2 por defecto
   iter=iter+1;
   z(iter+1,:)=x;
   x0=x;
end

if incre>tol
   disp('No hay convergencia')
end

for k=2:iter
   tcl(k-1)=abs(z(k+1,:)-z(k,:))/(abs(z(k,:)-z(k-1,:)));
end

for k=2:iter
   tcc(k-1)=(norm(z(k+1,:)-z(k,:)))/((norm(z(k,:)-z(k-1,:))).^2);
end

%end of fixedpoint 