function [node,n_tx,n_tx2,n_tx3,node_energy,node_energy2,node_energy3]=simula(C,D,T,R,s,node_energy)

%INPUTS------------------------------
%C is a vector(row) that symbolizes the tx power
%D is a vector(row) that symbolizes the electronic power
%R is the transmission rate
%s is the packet size
%T total path latency
%node_energy is the energy of each node 

%OUTPUTS
%n_tx is the n of transmission for our protocol
%n_tx2 the transmissions for the Non-Power-aware
%n_tx3 the transmissions for the Power-aware
%------------------------------------
%rate determines in our algorithm the up-date frequency 
%of the modulation parameters of the whole path


b=0;
rate=100;
n_tx=0;
n_tx2=0;
n_tx3=0;
node_energy2=node_energy;
node_energy3=node_energy;

%#########################NON POWER AWARE PROTOCOL####################
a=1;
Emax=energy_model2(C,D,R,s,10);

while a >= 0    
        n_tx2=n_tx2+1;
        
        for i=1:length(C)
            node_energy2(i)=node_energy2(i)-Emax(i);
            if node_energy2(i) <= 0
                fprintf('NON-AWARE protocol:number of total tx was %d \n',n_tx2);
                a=-1;
            end
        end
end


%#########################POWER AWARE PROTOCOL #############
a=1;
bop=optimal_b(T,C,D,R,s);
Eop=energy_model2(C,D,R,s,bop);

while a >= 0
    n_tx3=n_tx3+1;
        
    for i=1:length(C)
        node_energy3(i)=node_energy3(i)-Eop(i);
        if node_energy3(i) <= 0
            fprintf('AWARE protocol:number of total tx was %d \n',n_tx3);
            a=-1;
        end
    end
end

%#########################POWER AWARE PROTOCOL (BALANCING)#############

a=1;
while a >= 0
    
    %main also computes the tx of 1 packet over all the path
    [node,groups_balanced,not_balanced]=main(C,D,T,R,s,node_energy);
    n_tx=n_tx+1;
    
  
    for i=1:length(node)
        node_energy(i)=node(i).energy;
        C(i)=node(i).C;
        D(i)=node(i).D;
        b(i)=node(i).b;
        
        if node_energy(i) <= 0
            fprintf('node %d is down \n',node(i).index);
            fprintf('number of total tx was %d \n',n_tx);
            a=-1;
        end
    end
    
    if a==-1
         return
    end
 
    E=energy_model2(C,D,R,s,b);
    for i=1:rate
        n_tx=n_tx+1;
        for i=1:length(node)
            node_energy(i)=node_energy(i)-E(i);
            node(i).energy=node_energy(i);
            if node_energy(i) <= 0
                fprintf('node %d is down \n',node(i).index);
                fprintf('number of total tx was %d \n',n_tx);
                a=-1;
            end
        end
        
        if a==-1
            return
        end
    end    
end
